from edge.services.types.controller import ControllerServiceConf, IControllerService


class _ControllerService(IControllerService):
    def __init__(self, conf: ControllerServiceConf) -> None:
        self._conf = conf

    @property
    def systest_session_active(self) -> bool:
        return self._conf.systest_session_active

    @property
    def allow_transit(self) -> bool:
        return self._conf.event_policy in ['all', 'transit']

    @property
    def allow_violation(self) -> bool:
        return self._conf.event_policy in [ 'all' ]

    def serialize(self, jnode: dict) -> dict:
        if self._conf.cert_jnode:
            jnode.update({'certificate': self._conf.cert_jnode})

        return jnode


def init_service(conf: ControllerServiceConf) -> IControllerService:
    return _ControllerService(conf)
