from abc import abstractmethod
from typing import Final

from edge.services.types.service import IService


class ControllerServiceConf:
    def __init__(self, systest_session_active: bool,  event_policy: str, cert_jnode: dict | None = None) -> None:
        self.systest_session_active: Final[bool] = systest_session_active
        self.event_policy: Final[str] = event_policy
        self.cert_jnode: Final[dict | None] = cert_jnode


class IControllerService(IService):
    @property
    @abstractmethod
    def systest_session_active(self) -> bool:
        pass

    @property
    @abstractmethod
    def allow_transit(self) -> bool:
        pass

    @property
    @abstractmethod
    def allow_violation (self) -> bool:
        pass

    @abstractmethod
    def serialize(self, jnode: dict) -> dict:
        pass
